;Invio.asm
.286c
.MODEL  SMALL

INTERRUPT_NUM   EQU             9	;Interrupt da intercettare
                

ROM_BIOS_DATA   SEGMENT AT      40H		;Questi sono dati memorizzati
                ORG             1AH		;nel BIOS all'ind. 0040:001A
                HEAD            DW      ?	;Puntatore alla testa del buffer
                TAIL            DW      ?	;Puntature alla coda del buffer
                BUFF            DW      16 DUP(?);Buffer
                BUFF_END        LABEL   WORD
ROM_BIOS_DATA   ENDS

                .CODE
                ORG             100H
FIRST:          JMP             LOAD_PROG	;Carico in memoria il prg.
                OLD_KEYBOARD_INT DD     ?	;memorizza l'indirizzo al 
						;vecchio vettore di int.
                

PROG            PROC
                pusha		;salvo i registri
                pushf	
		
                call OLD_KEYBOARD_INT	;chiamo la vecchia routine di int.

                ASSUME  ds:ROM_BIOS_DATA
		
                push    ds
                mov     bx,ROM_BIOS_DATA	;Questo gruppo di istruzioni
                mov     ds,bx			;mi serve per gestire il buffer
                mov     bx,TAIL			;dei caratteri letti
                cmp     bx,HEAD
                je      EXIT			;Non ci sono caratteri
                sub     bx,2                    ;si sposta di due bytes
                cmp     bx,OFFSET BUFF          ;controlla di non uscire
                jae     NO_WRAP
                mov     bx,OFFSET BUFF_END
                sub     bx,2			;BX punta al carattere
NO_WRAP:        mov     dx,[bx]			;in DL c' il carattere letto


;QUI CI VA IL PROGRAMMA: In questo esempio ho deciso di stampare
;una freccina se il carattere premuto  invio
;---------------------------------------------------------------
                cmp     dl,0Dh  ;il carattere letto  INVIO ?
                jne     EXIT    ;se no esci
                mov     al,27   ;altrimenti stampa freccina
                mov     cx,1    ;1 volta
                mov     bh,0    ;sulla prima pagina
                mov     ah,0Ah  
                int     10h
;---------------------------------------------------------------

EXIT:
                pop     ds
		popa                
                iret
PROG            ENDP

LOAD_PROG       PROC			;Precedura che carica in memoria il prg.
                mov     ah,35h                
		mov     al,INTERRUPT_NUM
                int     21h			;Prelevo il vecchio vettore 
                mov     WORD PTR OLD_KEYBOARD_INT,bx               
		mov     WORD PTR OLD_KEYBOARD_INT[2],es
		
		mov	al,INTERRUPT_NUM
                mov     ah,25h
                lea     dx,PROG 
                int     21h			;Imposto quello nuovo
		
                mov     dx,OFFSET LOAD_PROG	;in DX ci va l'ultimo byte del
                                                ;prg.+1
                int     27h			;Termina ma rimani in memoria
LOAD_PROG       ENDP
                END     FIRST
